//
//  Carta.swift
//  poker
//
//  Created by Mobile Roshka on 4/13/20.
//  Copyright © 2020 Mobile Roshka. All rights reserved.
//

import Foundation

struct Carta{
    var valor = Int()
    //var nombre = String()
    var palo = Palo.self
    //var palo = String()
    enum Palo: Int{
        case E = 1
        case T = 2
        case C = 3
        case D = 4
    }
    
}

class Baraja{
   // var enMesa = [String]()
    var valor = [Int]()
    var valoresOrdenados = [Int]()
    var palo = [String]()
    var nombreCarta = [String]()
    var nombreJugada = "Carta alta"
    private let escalera: [Int] = [1, 10, 11, 12, 13]
    
    //función para extraer 5 cartas y guardar la información en arrays con los valores, el palo y el nombre de la carta en caso de ser A, J, Q y K
    func extraerCartas()/*->[String]*/{
        let carta = Carta.init()
        
        //recorremos un array de 5 elementos (cada una de las cartas extraídas)
        for index in 0...4{
        //se elige al azar el palo segun el enum de palo
        var paloCarta = carta.palo.init(rawValue:  .random(in: 1...4))
            
        //se guarda en el array los valores de la carta y el palo
        valor.append(Int.random(in: 1...13))
        palo.append("\(paloCarta!)")
            
        //se recorre por los elementos anteriores para determinar si se repitió la carta y si es así escojemos otra
        for i in 0..<index{
            if valor[index] == valor[i] && palo[index] == palo[i]{
                valor.removeLast()
                palo.removeLast()
                valor.append(Int.random(in: 1...13))
                paloCarta = carta.palo.init(rawValue: Int.random(in: 1...4))
                palo.append("\(paloCarta!)")
            }
        }
        // se carga en el array auxiliar, que luego se ordenará
        valoresOrdenados.append(valor[index])
            
        //se carga en el array el nombre de la carta, 1: A, 11:J, 12:Q y 13:K
        switch valor[index] {
            case 1:
                nombreCarta.append("A"/*+"\(paloCarta!)"*/)
            case 11:
                nombreCarta.append("J"/*+"\(paloCarta!)"*/)
            case 12:
                nombreCarta.append("Q"/*+"\(paloCarta!)"*/)
            case 13:
                nombreCarta.append("K"/*+"\(paloCarta!)"*/)
            default:
                nombreCarta.append("\(valor[index])"/*+"\(paloCarta!)"*/)
            }
        }
        valoresOrdenados.sort()
        return //nombreCarta
        }
    
    //devuelve un string con el nombre de la jugada segun la combinación de cartas
    func jugadas()->String{
        
        var contSecuencia = 1
        var contPalosIguales = 1
        var diccionarioCantidad: [Int: Int] = [1: 0, 2: 0, 3: 0, 4: 0, 5: 0, 6: 0, 7: 0, 8: 0, 9: 0, 10: 0, 11: 0, 12: 0, 13: 0]
        diccionarioCantidad[valoresOrdenados[0]]! += 1
        for index in 1...4{
                if valoresOrdenados[index] == valoresOrdenados[index-1]+1{
                    contSecuencia += 1
                    }
                if palo[index] == palo[index-1]{
                    contPalosIguales += 1
                }
                if diccionarioCantidad[valoresOrdenados[index]] == 0{
                diccionarioCantidad[valoresOrdenados[index]]! += 1
                }
                if valoresOrdenados[index] == valoresOrdenados[index - 1]{
                    diccionarioCantidad[valoresOrdenados[index]]! += 1
                }
        }
        if contPalosIguales == 5{
            nombreJugada = "Color"
        }
        if contSecuencia == 5{
            nombreJugada = "Escalera"
        }
        if valoresOrdenados == escalera{
            nombreJugada = "Escalera"
        }
        if nombreJugada == "Escalera" && contPalosIguales == 5 {
            nombreJugada = "Escalera Color"
        }
        let poker = diccionarioCantidad.filter{ $0.value == 4}
        let trio = diccionarioCantidad.filter{ $0.value == 3}
        let par = diccionarioCantidad.filter{ $0.value == 2}
        if par.count == 1{
            nombreJugada = "Par"
        }
        if par.count == 2{
            nombreJugada = "Par doble"
        }
        if trio.count == 1{
            nombreJugada = "Trio"
        }
        if par.count == 1 && trio.count == 1{
            nombreJugada = "Full"
        }
        if poker.count == 1 {
            nombreJugada = "Poker"
        }
        return nombreJugada
        
    }
    
    //eliminamos todas las modificaciones para empezar de nuevo el juego
    func barajarCartas(){
        valor.removeAll()
        palo.removeAll()
        valoresOrdenados.removeAll()
        nombreCarta.removeAll()
        nombreJugada = "Carta alta"
    }
    
    
}
